   --  ,  
   --      
   --------------------------------------------
   import Prelude hiding (elem)
   --------------------------------
   elem:: Ord a => a -> [a] -> Bool
   elem x lst | null lst    = False
              | head lst==x = True
              | True        = elem x (tail lst)
   --------------------------------------------
   elem1:: Ord a => a -> [a] -> Bool
   elem1 x lst = not (elem' x lst)
      where elem' x lst | null lst = True
                        | True     = x/=head lst && 
                                     elem' x (tail lst)
   ----------------------------------------------------
   elem2:: Ord a => a -> [a] -> Bool
   elem2 x lst = or (map (==x) lst)
   ---------------------------------
   elem3:: Ord a => a -> [a] -> Bool
   elem3 x lst | null lst = False
               | True     = x==head lst || elem3 x (tail lst)
   ----------------------------------------------------------
   --   :
   ------------------------------
   test =   elem 5 [1,2,5,6]
         && not (elem 5 [1,2,3])
         && elem [1,2] [[1,2],[4,5,6]]
         -----------------------------
         && elem1 5 [1,2,5,6]
         && not (elem1 5 [1,2,3])
         && elem1 [1,2] [[1,2],[4,5,6]]
         ------------------------------
         && elem2 5 [1,2,5,6]
         && not (elem2 5 [1,2,3])
         && elem2 [1,2] [[1,2],[4,5,6]]
         ------------------------------
         && elem3 5 [1,2,5,6]
         && not (elem3 5 [1,2,3])
         && elem3 [1,2] [[1,2],[4,5,6]]
